!= Program ArareInitData
!
! Authors::   SUGIYAMA Ko-ichiro (̰ϯ), ODAKA Masatsugu ()
! Version::   $Id: arare_init-data.f90,v 1.3 2011-03-28 01:48:53 sugiyama Exp $
! Tag Name::  $Name: arare4-20111026 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
! ϳإǥ deepconv/arare. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ϤϽవ̷.
!
!== Future Plans
!
!

program ArareInitData
  !
  !ϳإǥ deepconv/arare. 
  !

  !----- ⥸塼ɤ߹ ------

  !-----   , ʸ   ----
  use dc_types,       only : STRING
  use dc_string,      only : StoA

  !-----   å   -----
  use dc_message,     only: MessageNotify

  !  ޥɥ饤
  use argset,        only : argset_init  

  !-----    ⥸塼   -----
  !  ̷׻⥸塼
  use ChemCalc, only: ChemCalc_init
  use chemdata, only: chemdata_init

  !  ϥե̾⥸塼
  use fileset,    only : fileset_init

  !  ǥХåϴ⥸塼
  use debugset,      only : debugset_init

  !  ʻ⥸塼 
  use gridset,       only : gridset_init, &
    &                       DimXMin, DimXMax, DimZMin, DimZMax, SpcNum

  !  ܾ⥸塼
  use basicset,      only : basicset_init

  !  롼⥸塼
  use moistset,      only: moistset_init

  !  Ŭѥ⥸塼
  use boundary,    only : BoundaryXCyc_xz, BoundaryZSym_xz,     &
    &                      BoundaryXCyc_xza, BoundaryZSym_xza,   &
    &                      BoundaryXCyc_pz, BoundaryZSym_pz,     &
    &                      BoundaryXCyc_xr, BoundaryZAntiSym_xr

  !-----    ϥ⥸塼   -----
  !  ꥹȥեϥ⥸塼
  use RestartFileIO, only : ReStartFile_Open, ReStartFile_OutPut, &
    &                     ReStartFile_Close

  !ۤηػ
  implicit none

  !ѿ
  character(80) :: cfgfile
  real(8), allocatable :: pz_VelXBl(:,:)
  real(8), allocatable :: xr_VelZBl(:,:)
  real(8), allocatable :: xz_ExnerBl(:,:)
  real(8), allocatable :: xz_PotTempBl(:,:)
  real(8), allocatable :: xz_KmBl(:,:)
  real(8), allocatable :: xz_KhBl(:,:)
  real(8), allocatable :: xza_MixRtBl(:,:,:)
  real(8)              :: Time
  integer              :: i, cpu

  !NAMELIST ե̾ɤ߹
  call MessageNotify( "M", "main", "Namelist file is '%c'", c1=trim(cfgfile) )
  call argset_init(cfgfile)

  !ǥХå
  call debugset_init(cfgfile)

  !ʪν
  call chemdata_init()

  !ʻν
  !  NAMELIST , ʻ׻
  call gridset_init(cfgfile)

  !ط׻롼ν
  call chemcalc_init()
  
  !ܾξν
  !  NAMELIST , ܾꤹ.
  call basicset_init(cfgfile)
  
  !I/O ե̾ν
  !  NAMELIST ե̾ꤷ, deepconv/arare 
  !  ϥե̾ NAMELIST 
  call fileset_init(cfgfile)

  !롼ζͭѿν
  call moistset_init()

  !ѿν. ȤꤢͤꤵƤ. 
  call ArareAlloc

  ! CPU 
  call ArareSetCPU

  ! ǥեδܾ, . 
  Time = 0.0d0
  do i = 1, cpu     
    ! ܾͤ׻. ͤ⥸塼ݴ.
    call BasicEnv_init(i, cpu, cfgfile)
    
    ! ͤ׻
    call DisturbEnv_init(i, cpu, cfgfile,                  &
      & xz_PotTempBl, xz_ExnerBl, pz_VelXBl, xr_VelZBl, &
      & xza_MixRtBl,  xz_KmBl,    xz_KhBl               )
    
    ! ꥹȥե. ܾȾ. 
    call ReStartFile_Open( )
    call ReStartFile_OutPut(                            &
      & Time,                                           &
      & xz_PotTempBl, xz_ExnerBl, pz_VelXBl, xr_VelZBl, &
      & xza_MixRtBl,  xz_KmBl,    xz_KhBl               )
    call ReStartFile_Close
  end do
  
contains

  subroutine ArareSetCPU
    ! 
    NAMELIST /arare_cpu/ cpu

    !ե륪ץ. . 
    open (10, FILE=cfgfile)
    read(10, NML=arare_cpu)
    close(10)

  end subroutine ArareSetCPU


  subroutine ArareAlloc
    !
    !Ȥ, , ͤȤƥ.
    !

    !ۤηػ
    implicit none

    !
    allocate(                                                  &
      & pz_VelXBl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xr_VelZBl(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xz_ExnerBl(DimXMin:DimXMax, DimZMin:DimZMax),          &
      & xz_PotTempBl(DimXMin:DimXMax, DimZMin:DimZMax),        &
      & xz_KmBl(DimXMin:DimXMax, DimZMin:DimZMax),             &
      & xz_KhBl(DimXMin:DimXMax, DimZMin:DimZMax),             &
      & xza_MixRtBl(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum))

    pz_VelXBl = 0.0d0
    xr_VelZBl = 0.0d0
    xz_ExnerBl = 0.0d0
    xz_KmBl = 0.0d0
    xz_KhBl = 0.0d0
    xz_PotTempBl = 0.0d0
    xza_MixRtBl = 0.0d0
  end subroutine ArareAlloc
    
end program ArareInitData
